org.apache.http.impl.io

## Class IdentityInputStream

- java.lang.Object
- - java.io.InputStream
  - - org.apache.http.impl.io.IdentityInputStream

All Implemented Interfaces:
  Closeable, AutoCloseable

    @NotThreadSafe
    public class IdentityInputStream
    extends InputStream

Input stream that reads data without any transformation. The end of the content entity is demarcated by closing the underlying connection (EOF condition). Entities transferred using this input stream can be of unlimited length.

Note that this class NEVER closes the underlying stream, even when close gets called. Instead, it will read until the end of the stream (until `-1` is returned).

Since:
  4.0

### Constructor Summary

Constructors
Constructor and Description
`IdentityInputStream(SessionInputBuffer in)` Wraps session input stream and reads input until the the end of stream.

### Method Summary

Methods
`int` `available()`
`void` `close()`
`int` `read()`
`int` `read(byte[] b, int off, int len)`

### Methods inherited from class java.io.InputStream

`mark, markSupported, read, reset, skip`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### IdentityInputStream

    public IdentityInputStream(SessionInputBuffer in)

Wraps session input stream and reads input until the the end of stream.

Parameters:
  `in` - The session input buffer

### Method Detail

#### available

    public int available()
                  throws IOException

Overrides:
  `available` in class `InputStream`
Throws:
  `IOException`

#### close

    public void close()
               throws IOException

Specified by:
  `close` in interface `Closeable`
Specified by:
  `close` in interface `AutoCloseable`
Overrides:
  `close` in class `InputStream`
Throws:
  `IOException`

#### read

    public int read()
             throws IOException

Specified by:
  `read` in class `InputStream`
Throws:
  `IOException`

#### read

    public int read(byte[] b,
           int off,
           int len)
             throws IOException

Overrides:
  `read` in class `InputStream`
Throws:
  `IOException`